/*++++++++++++++++ AppTFG +++++++++++++++++++
Desarollada por Daniel Sierra
Para conectar vía Bluetooth con Robot auto balanceado
Estudiante de ingenieria electrónica y autómatica
Universidad de Valladolid
Tutor Luis Carlos Herrero

Bibliografia:
http://www.innovadomotics.com/mn-tuto/mn-android/proyectos/23-and-cnm-bt.html?start=4
 +++++++++++++++++++++++++++++++++++++++++++++*/


package com.example.tfgapp;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Button;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.UUID;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.os.Handler;
import android.widget.Toast;
import android.widget.EditText;

public class MainActivity extends AppCompatActivity {

    //Variables para todos los objetos en el Layout.
    Button idEnviar, idApagar, idDesconectar;
    Button idKpSubir, idKpBajar, idKdSubir, idKdBajar, idKiSubir, idKiBajar;
    TextView idBufferin;
    EditText idKi,idKp,idKd;
    EditText idKiIncremento,idKpIncremento,idKdIncremento;
    String mensaje = null;

    Handler bluetoothIn;
    final int handlerState = 0;
    private BluetoothAdapter btAdapter = null;
    private BluetoothSocket btSocket = null;
    private StringBuilder DataStringIN = new StringBuilder();
    private ConnectedThread MyConexionBT;
    // Identificador unico de servicio - SPP UUID
    private static final UUID BTMODULEUUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
    // String para la direccion MAC
    private static String address = null;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        idEnviar = (Button) findViewById(R.id.idEnviar);
        idApagar = (Button) findViewById(R.id.idapagar);
        idDesconectar = (Button) findViewById(R.id.idDesconectar);
        idBufferin = (TextView) findViewById(R.id.idBuffer);
        idKi = (EditText) findViewById(R.id.idCajaKi);
        idKp = (EditText) findViewById(R.id.idCajaKp);
        idKd = (EditText) findViewById(R.id.idCajaKd);
        idKpSubir = (Button) findViewById(R.id.idKpSubir);
        idKiSubir = (Button) findViewById(R.id.idKiSubir);
        idKdSubir = (Button) findViewById(R.id.idKdSubir);
        idKpBajar = (Button) findViewById(R.id.idKpBajar);
        idKiBajar = (Button) findViewById(R.id.idKiBajar);
        idKdBajar = (Button) findViewById(R.id.idKdBajar);
        idKiIncremento = (EditText) findViewById(R.id.idKiIncremento);
        idKpIncremento = (EditText) findViewById(R.id.idKpIncremento);
        idKdIncremento = (EditText) findViewById(R.id.idKdIncremento);

        bluetoothIn = new Handler() {
            public void handleMessage(android.os.Message msg) {
                if (msg.what == handlerState) {
                    String readMessage = (String) msg.obj;
                    DataStringIN.append(readMessage);

                    int endOfLineIndex = DataStringIN.indexOf("#");

                    if (endOfLineIndex > 0) {
                        String dataInPrint = DataStringIN.substring(0, endOfLineIndex);
                        idBufferin.setText("Dato: " + dataInPrint);
                        DataStringIN.delete(0, DataStringIN.length());
                    }
                }
            }
        };

        btAdapter = BluetoothAdapter.getDefaultAdapter(); // get Bluetooth adapter
        VerificarEstadoBT();

        //Envia mensaje con los valores K que se han seleccionado.
        idEnviar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                mensaje = null;
                //El mensaje se compone de los 3 valores en cada una de cajas de texto.
                mensaje = idKp.getText().toString() +","+ idKi.getText().toString() +","+ idKd.getText().toString();
                MyConexionBT.write(mensaje);
                idBufferin.setText(mensaje);

            }
        });

        //Aumenta el valor de K al que corresponde.
        idKpSubir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                String Sincremento = idKpIncremento.getText().toString();
                Double incremento = Double.parseDouble(Sincremento);
                Double Resultado = incremento + Double.parseDouble(idKp.getText().toString());
                idKp.setText("");
                idKp.setText(""+Resultado+"");
            }
    });
        //Aumenta el valor de K al que corresponde.
        idKdSubir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                String Sincremento = idKdIncremento.getText().toString();
                Double incremento = Double.parseDouble(Sincremento);
                Double Resultado = incremento + Double.parseDouble(idKd.getText().toString());
                idKd.setText("");
                idKd.setText(""+Resultado+"");
            }
        });
        //Aumenta el valor de K al que corresponde.
        idKiSubir.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                String Sincremento = idKiIncremento.getText().toString();
                Double incremento = Double.parseDouble(Sincremento);
                Double Resultado = incremento + Double.parseDouble(idKi.getText().toString());
                idKi.setText("");
                idKi.setText(""+Resultado+"");
            }
        });
        //Disminuye el valor de K al que corresponde.
        idKpBajar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                String Sincremento = idKpIncremento.getText().toString();
                Double incremento = Double.parseDouble(Sincremento);
                Double Resultado = - incremento + Double.parseDouble(idKp.getText().toString());
                idKp.setText("");
                idKp.setText(""+Resultado+"");
            }
        });
        //Disminuye el valor de K al que corresponde.
        idKdBajar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                String Sincremento = idKdIncremento.getText().toString();
                Double incremento = Double.parseDouble(Sincremento);
                Double Resultado = - incremento + Double.parseDouble(idKd.getText().toString());
                idKd.setText("");
                idKd.setText(""+Resultado+"");
            }
        });
        //Disminuye el valor de K al que corresponde.
        idKiBajar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                String Sincremento = idKiIncremento.getText().toString();
                Double incremento = Double.parseDouble(Sincremento);
                Double Resultado = - incremento + Double.parseDouble(idKi.getText().toString());
                idKi.setText("");
                idKi.setText(""+Resultado+"");
            }
        });

        //Envia un mensaje para deshabilitar o habilitar el robot.
        idApagar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if(mensaje == "-1,-1,-1"){
                    mensaje = idKp.getText().toString() +","+ idKi.getText().toString() +","+ idKd.getText().toString();
                    MyConexionBT.write(mensaje);
                    idBufferin.setText(mensaje);
                }
                else{
                    mensaje = "-1,-1,-1";
                    MyConexionBT.write(mensaje);
                    idBufferin.setText(mensaje);
                }

            }
        });
        //Desconectar la conexión con el módulo Bluetooth.
        idDesconectar.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (btSocket != null) {
                    try {
                        btSocket.close();
                    } catch (IOException e) {
                        Toast.makeText(getBaseContext(), "Error", Toast.LENGTH_SHORT).show();

                    }
                }
                finish();
            }
        });

    }

    private BluetoothSocket createBluetoothSocket(BluetoothDevice device) throws IOException {
        //crea un conexion de salida segura para el dispositivo
        //usando el servicio UUID
        return device.createRfcommSocketToServiceRecord(BTMODULEUUID);
    }

    @Override
    public void onResume() {
        super.onResume();
        //Consigue la direccion MAC desde DeviceListActivity via intent
        Intent intent = getIntent();
        //Consigue la direccion MAC desde DeviceListActivity via EXTRA
        address = intent.getStringExtra(dispositivosBT.EXTRA_DEVICE_ADDRESS);//<-<- PARTE A MODIFICAR >->->
        //Setea la direccion MAC
        BluetoothDevice device = btAdapter.getRemoteDevice(address);

        try {
            btSocket = createBluetoothSocket(device);
        } catch (IOException e) {
            Toast.makeText(getBaseContext(), "La creacción del Socket fallo", Toast.LENGTH_LONG).show();
        }
        // Establece la conexión con el socket Bluetooth.
        try {
            btSocket.connect();
        } catch (IOException e) {
            try {
                btSocket.close();
            } catch (IOException e2) {
            }
        }
        MyConexionBT = new ConnectedThread(btSocket);
        MyConexionBT.start();
    }

    @Override
    public void onPause() {
        super.onPause();
        try { // Cuando se sale de la aplicación esta parte permite
            // que no se deje abierto el socket
            btSocket.close();
        } catch (IOException e2) {
        }
    }

    //Comprueba que el dispositivo Bluetooth Bluetooth está disponible y solicita que se active si está desactivado
    private void VerificarEstadoBT() {

        if (btAdapter == null) {
            Toast.makeText(getBaseContext(), "El dispositivo no soporta bluetooth", Toast.LENGTH_LONG).show();
        } else {
            if (btAdapter.isEnabled()) {
            } else {
                Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
                startActivityForResult(enableBtIntent, 1);
            }
        }
    }

    private class ConnectedThread extends Thread {
        private final InputStream mmInStream;
        private final OutputStream mmOutStream;

        public ConnectedThread(BluetoothSocket socket) {
            InputStream tmpIn = null;
            OutputStream tmpOut = null;
            try {
                tmpIn = socket.getInputStream();
                tmpOut = socket.getOutputStream();
            } catch (IOException e) {
            }
            mmInStream = tmpIn;
            mmOutStream = tmpOut;
        }




    public void run()

    {
        byte[] buffer = new byte[256];
        int bytes;

        // Se mantiene en modo escucha para determinar el ingreso de datos
        while (true) {
            try {
                bytes = mmInStream.read(buffer);
                String readMessage = new String(buffer, 0, bytes);
                // Envia los datos obtenidos hacia el evento via handler
                bluetoothIn.obtainMessage(handlerState, bytes, -1, readMessage).sendToTarget();
            } catch (IOException e) {
                break;
            }
        }
    }
    //Envio de trama
    public void write(String input)
    {
        try {
            mmOutStream.write(input.getBytes());
        }
        catch (IOException e)
        {
            //si no es posible enviar datos se cierra la conexión
            Toast.makeText(getBaseContext(), "La Conexión fallo", Toast.LENGTH_LONG).show();
            finish();
        }
    }

}
}